/* gcc -std=c99 qrtest.c -o qrtest -I/usr/include/R -L/usr/lib64/R/lib -lR -lm */

//#define MATHLIB_STANDALONE 1
//#include <Rmath.h>
#include <R_ext/Applic.h>

#include <stdio.h>
#include <stdlib.h>

#define N 536870912
#define P 4

void print_matrix(double *x, int n, int p, int start, int end)
{
    for (int i = start; i < end; i++) {
	for (int j = 0; j < p; j++)
	    printf("%8f ", x[i + ((size_t) n) * j]);
	printf("\n");
    }
}

int
main(int argc, char** argv)
{
    int n = N;
    int p = P;
    int rank;
    double tol = 1e-07;

    double *x = calloc(((size_t) N) * P, sizeof(double));
    double qraux[P];
    int pivot[P];
    double work[2 * P];

    if (x == NULL) {
	fprintf(stderr, "allocation failed\n");
	exit(1);
    }

    for (int i = 0; i < p; i++)
	pivot[i] = i + 1;

    for (int i = 0; i < p; i++)
	if (p > 0) {
	    x[n - p + i] = 1.0;
	    if (p > 1) {
		x[n - p + i + ((size_t) n)] = i + 1.0; 
		for (int j = 2; j < p; j++)
		    x[i + n - p + ((size_t) n) * j] =
			(i + 1.0) * x[i + n - p + ((size_t) n) * (j - 1)];
	    }
	}

    print_matrix(x, n, p, n - p, n);

    F77_CALL(dqrdc2)(x, &n, &n, &p, &tol, &rank, qraux, pivot, work);
    
    print_matrix(x, n, p, 0, p);

    return 0;
}
